      PROGRAM INTEGRALES
      
      REAL K(30),R,RS,INT0,E,T0,RAIZ,INCR,INT,DINT1
      REAL IT,F1,F2,DF3,DF4,DIT1,NR,F10,F20,IT0
      EXTERNAL IT,F1,F2,DF3,DF4,DIT1,NR,F10,F20,IT0
      DATA INCR,RS,E,T0 /1E-3,20,1E-4,100/
      OPEN (10,FILE='RESULTADOS.TXT',STATUS='UNKNOWN')
      INT0=IT0(X,F10,X1,F20,INCR)
      R=1
        DOWHILE (R.LE.30)
          K(R)=(RS/(2*R))**2
          K(R)=K(R)*INT0
          R=R+1
        ENDDO
          RAIZ=NR(T0,E,INT,DINT1,K,INCR)
        CLOSE(10)  
        END
      
****** VALOR DE LA FUNCION F0 PARA X MENOR QUE 1
      REAL FUNCTION F10(X)
      REAL X
      IF (X.EQ.0.) THEN
       F10=0.
      ELSE 
      F10=X**4/(EXP(X/100)-1)
      ENDIF
      RETURN
      END
****** VALOR DE LA FUNCION F0 PARA X MAYOR QUE 1
      REAL FUNCTION F20(X)
      REAL X
         F20=X/(EXP(X/100)-1)  
      RETURN
      END
****** FUNCION QUE CALCULA LA INTEGRAL IT0
      REAL FUNCTION IT0(X,F10,X1,F20,INCR)
      REAL X,X1,F10,F20,INCR
      EXTERNAL F10,F20
      X=0.
      X1=INCR
      IT0=0.
      DOWHILE (X1.LE.1)
        IT0=IT0+(F10(X)+F10(X1))*INCR/2.
        X=X1
        X1=X1+INCR
      ENDDO
      DOWHILE ((X1.GT.1).AND.(X1.LE.10))
        IT0=IT0+(F20(X)+F20(X1))*INCR/2
        X=X1              
        X1=X1+INCR
      ENDDO
      
      RETURN
      
      END      
****** VALOR DE LA FUNCION F1 PARA X MENOR QUE 1
      REAL FUNCTION F1(X,T)
      
      REAL X,T 
      IF (X.EQ.0.) THEN
        F1=0.
      ELSE
        F1=X**4/(EXP(X/T)-1)
      ENDIF
      RETURN
      END
****** VALOR DE LA FUNCION F1 PARA X MAYOR QUE 1
      REAL FUNCTION F2(X,T)
      COMMON /T/ D
      REAL X
        F2=X/(EXP(X/T)-1)  
      RETURN
      END
****** FUNCION QUE CALCULA LA INTEGRAL IT
      REAL FUNCTION IT(X,T,F1,X1,F2,INCR)
      REAL X,X1,F1,F2,INCR,T
      EXTERNAL F1,F2  
     
      X=0.
      X1=INCR
      IT=0.
      DOWHILE (X1.LE.1)
        IT=IT+(F1(X,T)+F1(X1,T))*INCR/2.
        X=X1
        X1=X1+INCR
      ENDDO
      DOWHILE ((X1.GT.1).AND.(X1.LE.10))
        IT=IT+(F2(X,T)+F2(X1,T))*INCR/2
        X=X1
        X1=X1+INCR
      ENDDO
  
      RETURN
      
      END

*****CALCULA EL VALOR DE DF(T) PARA X MENOR QUE 1

      REAL FUNCTION DF3(X,T)
   
      REAL X,T
      
      IF (X.EQ.0) THEN
       DF3=0.
      ELSE
       DF3=(X**5)*EXP(X/T)/((EXP(X/T)-1)**2)
       DF3=DF3/(T*T)
      ENDIF
      RETURN
      END

****** CALCULA EL VALOR DE DF(T) PARA X MAYOR QUE 1
      REAL FUNCTION DF4(X,T)
   
      REAL X,T
      
       DF4=X*X*EXP(X/T)/((EXP(X/T)-1)**2)
       DF4=DF4/(T*T)
      RETURN
      END
****** FUNCION QUE CALCULA LA INTEGRAL DIT1
      REAL FUNCTION DIT1(X,T,DF3,X1,DF4,INCR)
      REAL X,X1,DF3,DF4,INCR,T
      EXTERNAL DF3,DF4
      
      X=0.
      X1=INCR
      DIT1=0.
      DOWHILE (X1.LE.1)
        DIT1=DIT1+(DF3(X,T)+DF3(X1,T))*INCR/2.
        X=X1
        X1=X1+INCR
      ENDDO
      DOWHILE ((X1.GT.1).AND.(X1.LE.10))
        DIT1=DIT1+(DF4(X,T)+DF4(X1,T))*INCR/2
        X=X1
        X1=X1+INCR
      ENDDO 
   
      RETURN
      
      END 
****** FUNCION DE NEWTON-RAPHSON      
      REAL FUNCTION NR(T0,E,INT,DINT1,K,INCR)
      REAL IT,DIT1,X,X1,F1,F2,INCR,K(30),DF3,DF4,INT,DINT1
        EXTERNAL IT,DIT1,F1,F2,DF3,DF4 
        REAL T,T0,R,N,S(30)                 
        INCR=1E-3
                
        R=1 
            DOWHILE (R.LE.30)
              T0=100
              T=T0
              N=0
              DOWHILE ((ABS(INT-K(R)).GE.E).AND.(N.LE.20))
                 
                INT=IT(X,T,F1,X1,F2,INCR)
                DINT1=DIT1(X,T,DF3,X1,DF4,INCR)
                  IF (ABS(INT-K(R)).LT.E) THEN 
                        NR=T
                        S(R)=NR
                        PRINT*,'VALOR DE T(',R,')=',NR
                        PRINT*,'VALOR DE F(',T,')=',INT-K(R)
                        PRINT '(/)'   
C                        PAUSE
                  END IF
C                PRINT*,'VALOR DE LA R',R
C                PRINT*,'VALOR DE T',T  
C                PRINT*,'VALOR DE LA INTEGRAL',INT
C                PRINT*,'VALOR DE K(',R,')*INT0',K(R)  
C                PRINT*,'VALOR DE LA FUNCION',INT-K(R)
C                PRINT*,'VALOR DE LA DERIVADA',DINT1
  
                      T=T-(INT-K(R))/DINT1 
                      
C                PRINT*,'VALOR DE T DESPUES DE LA ITERACION',T
C                PAUSE
                 IF ((N.EQ.20).AND.(ABS(INT-K(R)).GT.E)) THEN
                   PRINT*,'PARA R=',R,'   ESTO NO CONVERGE NI PATRAS'
                   PRINT*,'VALOR DE F(',NR,')=',INT-K(R)
                   PRINT*,'REDUCE EL EPSILON'
                   PRINT '(/)'
                 ENDIF
                N=N+1
              ENDDO 
            WRITE (10,'(F11.5)') S(R)
            R=R+1
            
          ENDDO
          RETURN 
        END                 
      
                