

         program  NIUTON

         implicit none
         integer niter
         parameter ( niter = 10000 )

         real x,xn,ft,dft,error
         integer iter

c       condicion inicial

         x = 0.5
         iter = 0
         error = 1.e-4
         call calcular(x,ft,dft)

c       empieza la marcha

         do while (abs(ft) .ge. error .and. iter .le. niter )
            iter = iter + 1
            call calcular(x,ft,dft)
            xn = x - ft/dft
            write(*,*)iter,x,ft,dft
            x = xn
         end do

c       bla,bla,bla

         if ( iter .gt. niter) then
            write(*,*)'con', niter ,'iteraciones'
            write(*,*)'solucion:',x
         else
            write(*,*)'solucion con error',error
            write(*,*)'x=',x
         end if



         end

C****************************************************

         Subroutine calcular(x,ft,dft)

         Real    x,ft,dft


c       Funcion
         ft = x*x*x/3. + x*x/2 + x -10.

c       derivada
         dft = x*x + x + 1.


         return
         end

C*************************************************************************

   